<?php

class cAffectation extends BaseController{

	/**
	 * Contrôleur de gestion des affectations
	 */
	public function index(){ 
		//chargement vue
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		
		//récupération applications
		$apps=DAO::getAll("application");
		
		//logique client
		$js=JsUtils::postAndBindTo(".application", "click", "cAffectation/formulaire","{idApplication: $(this).attr('id')}","#affectations");
		$this->loadView("vAffectation",array("apps"=>$apps,"js"=>$js));
	}

	
	/**
	 * affichage des liste des développeurs affectés et non affectés
	 */
	public function formulaire(){
		//récupération de l'application
		$_SESSION['app']=DAO::getOne("Application", "id='".$_POST['idApplication']."'");
		
		//récupération des développeurs affectés
		DAO::getOneToMany($_SESSION['app'], "affectations");
		$_SESSION['assignedDeveloppers']=array();
		
		foreach($_SESSION['app']->getAffectations() as $affectation){
			$idUtilisateur=$affectation->getIdUtilisateur();
			$user=DAO::getOne("utilisateur", "id=".$idUtilisateur);
			$_SESSION['assignedDeveloppers'][]=$user;
		}

		//récupération de tous les développeurs
		$developpers=DAO::getAll("utilisateur","idGroupe in (3,4)");

		//récupération de tous les développeurs non affectés
		$_SESSION['unassignedDeveloppers']=StrUtils::compareTwoArraysOfObject($developpers, $_SESSION['assignedDeveloppers']);
		
		//tableaux temporaires des affectations de développeurs
		$_SESSION['TemporaryAssignedDeveloppers']=$_SESSION['assignedDeveloppers'];
		$_SESSION['TemporaryUnassignedDeveloppers']=$_SESSION['unassignedDeveloppers'];
		
		$this->refresh($_SESSION['app'], $_SESSION['assignedDeveloppers'],$_SESSION['unassignedDeveloppers']);
	}
	
	
	/**
	 * refresh des tableaux de développeurs
	 * @param Application $app
	 * @param array $assignedDeveloppers
	 * @param array $unassignedDeveloppers
	 */
	public function refresh($app,$assignedDeveloppers,$unassignedDeveloppers){
		//logique client
		$js=JsUtils::postAndBindTo(".ckd", "click", "cAffectation/selectDeveloppersToDelete","{}","#affectations");
		$js.=JsUtils::postAndBindTo(".cka", "click", "cAffectation/selectDeveloppersToAdd","{}","#affectations");
		$js.=JsUtils::postAndBindTo("#btAdd", "click", "cAffectation/insertChoices","{}","#message");
		
		//chargement vue
		$this->loadView("vChoixAffectation",array("app"=>$app,"assignedDeveloppers"=>$assignedDeveloppers,"unassignedDeveloppers"=>$unassignedDeveloppers,"js"=>$js));
	}
	
	
	/**
	 * suppression des développeurs sélectionnés
	 * @param integer $id
	 */
	public function selectDeveloppersToDelete($id){
		$id=str_replace("ckd", "", $id[0]);
		
		//récupération de l'utilisateur
		$user=DAO::getOne("utilisateur", "id=".$id);
		
		//recherche de la place de l'objet dans le tableau
		$key=array_search($user, $_SESSION['TemporaryAssignedDeveloppers']);
		
		//suppression et ajout dans les tableaux adéquats
		unset($_SESSION['TemporaryAssignedDeveloppers'][$key]);
		$_SESSION['TemporaryUnassignedDeveloppers'][]=$user;

		$this->refresh($_SESSION['app'], $_SESSION['TemporaryAssignedDeveloppers'], $_SESSION['TemporaryUnassignedDeveloppers']);
	}
	
	
	/**
	 * ajout des développeurs sélectionnés
	 * @param integer $id
	 */
	public function selectDeveloppersToAdd($id){
		$id=str_replace("cka", "", $id[0]);
		
		//récupération de l'utilisateur
		$user=DAO::getOne("utilisateur", "id=".$id);
			
		//recherche de la place de l'objet dans le tableau
		$key=array_search($user, $_SESSION['TemporaryUnassignedDeveloppers']);
			
		//suppression et ajout dans les tableaux adéquats
		unset($_SESSION['TemporaryUnassignedDeveloppers'][$key]);
		$_SESSION['TemporaryAssignedDeveloppers'][]=$user;
		
		$this->refresh($_SESSION['app'], $_SESSION['TemporaryAssignedDeveloppers'], $_SESSION['TemporaryUnassignedDeveloppers']);
	}
	
	
	/**
	 * enregistrement des choix d'affectation
	 */
	public function insertChoices(){
		//récupération de toutes les instances d'affectation qui concernent l'application choisie, puis suppression
		$affectations=DAO::getAll("affectation","idApplication=".$_SESSION['app']->getId());
		foreach($affectations as $anAffectation){
			DAO::delete($anAffectation);
		}
		
		//ajout des nouvelles instances de la classe affectation
		foreach($_SESSION['TemporaryAssignedDeveloppers'] as $newAffectation){
			//instanciation nouvelle affectation
			$affectation=new Affectation();
			$affectation->setIdUtilisateur($newAffectation->getId());
			$affectation->setIdApplication($_SESSION['app']->getId());
			$affectation->setApplication(new Application($_SESSION['app']->getId()));
			$affectation->setUtilisateur(new Utilisateur($newAffectation->getId()));
			$affectation->setDateAffectation(date('d-m-y'));
			
			//insertion
			DAO::insert($affectation);
		}
		
		echo "Vos choix d'affectation ont été enregistrés";
	}
}