<?php
/**
 * Contrôleur de Gestion des applications
 * @author jc
 * @version 1.0.0.1
 */
class cApplication extends BaseController{

	/**
	 * Contrôleur de gestion des applications
	 */
	public function index(){ 
		//chargement vues
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->refresh();
		$this->loadView("vFooter",array("message"=>"Gestion des applications (Ajout, modification, suppression)"));
	}
	
	/**
	 * Utilisé pour l'affichage initial et le rafraîchissement après une modification
	 */
	public function refresh(){
		//Chargement des applications $apps 
		$apps=DAO::getAll("Application");
		//Application de la sélection d'applications 
		$selectedApps=SessionUtils::getArray("selectedApps");
		//logique client
		$js=JsUtils::getAndBindTo("#btAdd", "click", "cApplication/add","{}","#operation");
		$js.=JsUtils::getAndBindTo(".deleteOther", "click", "cApplication/confirmDelete","{}","#operation");
		$js.=JsUtils::getAndBindTo(".update", "click", "cApplication/update","{}","#operation");
		$js.=JsUtils::getAndBindTo(".ck", "click", "cApplication/select","{}","#message");
		$js.=JsUtils::setChecked("ck", $selectedApps);
		$js.=JsUtils::setChecked("ckAll", SessionUtils::getBoolean("ckAllApps"));
		$js.=JsUtils::getAndBindTo("#deleteMulti", "click", "cApplication/confirmDelete/multi","{}","#operation");
		if(sizeof($apps)>0)
			$js.=JsUtils::postAndBindTo("#ckAll", "click", "cApplication/selectAll/",'{ids: $("input:checkbox[class=ck]").map(function(){return this.value;}).get().join(",")}',"#message");
		
		$nb=sizeof($selectedApps);
		if($nb>0)
			$js.=JsUtils::doSomethingOn("#multi", "show");
		else
			$js.=JsUtils::doSomethingOn("#multi", "hide");
		//chargement vue
		$data=array("apps"=>$apps, "js"=>$js);
		$this->loadView("vApps", $data);
	}
	
	
	/**
	 * ajout d'une application
	 */
	public function add(){
		if($_SERVER['REQUEST_METHOD']=='POST'){
			//instanciation de la nouvelle application
			$app=new Application();
			$app->setDateCreation(date("d-m-y"));
			$app->setDescriptif($_POST['descriptif']);
			$app->setLibelle($_POST['libelle']);
			$app->setVersion($_POST['version']);
			
			//insertion
			if(DAO::insert($app)){
				Gui::showOne($app);
				echo " ajouté";
				
				//si des cas d'utilisation ont été saisis
				if(isset($_POST['libelleUseCaseAdd'])){
					foreach($_POST['libelleUseCaseAdd'] as $uc){
						if($uc!=''){
							//instanciation use case
							$useCase=new UseCase();
							$useCase->setApplication(new Application($app->getId()));
							$useCase->setLibelle($uc);
							//insertion
							DAO::insert($useCase);
						}
					}
				}
				echo JsUtils::get("cApplication/refresh","{}","#apps");
			}else
				echo "ajout impossible";
			echo JsUtils::doSomethingOn("#operation", "hide",200);
		}else{
			//logique client
			$js=JsUtils::postFormAndBindTo("#btValidAddApp", "click", "cApplication/add", "frmAddApp","#message",true);
			$js.=JsUtils::doSomeThingAndBindTo("#btCancelAddApp", "click", "#operation","hide",200);
			$js.=JsUtils::setHtmlAndBindTo("#btCancelAddApp", "click", "#message","Opération d\'ajout annulée");
			$js.=JsUtils::doSomethingOn("#operation", "show",400);
			$js.=JsUtils::setHtmlAndBindTo("#btValidAddRow", "click", "#message", "<input type='text'>");
				
			$app=new Application();
			$data=array("app"=>$app,"js"=>$js,"title"=>"Ajouter une application :","useCases"=>array());
			$this->loadView("vAddApp",$data);
		}
	}
	
	/**
	 * modification application
	 * @param integer $id
	 */
	public function update($id){
		if($_SERVER['REQUEST_METHOD']=='POST'){
			//récupération application
			$app=new Application();
			$app->setId($_POST['id']);
			$app->setDateCreation(date("d-m-y"));
			$app->setDescriptif($_POST['descriptif']);
			$app->setLibelle($_POST['libelle']);
			$app->setVersion($_POST['version']);
			
			//mise à jour
			if(DAO::update($app)){
				Gui::showOne($app);
				echo " modifié";
				//s'il y a des cas d'utilisation dans l'application
				if(isset($_POST['code'])){
					for ($i = 0; $i < sizeof($_POST['code']); $i++) {
						$useCase = new UseCase();
						$useCase->setCode($_POST['code'][$i]);
						//si libellé non vide
						if($_POST['libelleUseCase'][$i]!=''){
							$useCase->setLibelle(str_replace("'"," ",$_POST['libelleUseCase'][$i]));
							//modification
							DAO::update($useCase);
						}
						else{
							//suppression
							DAO::delete($useCase);
						}
					}
				}
				
				//si nouveaux use case à ajouter
				if(isset($_POST['libelleUseCaseAdd'])){
					foreach($_POST['libelleUseCaseAdd'] as $uc){
						//si use case non vide
						if($uc!='')
						$useCase=new UseCase();
						$useCase->setApplication(new Application($app->getId()));
						$useCase->setLibelle(str_replace("'"," ",$uc));
						//insertion
						DAO::insert($useCase);
					}
				}
				
				echo JsUtils::get("cApplication/refresh","{}","#apps");
			}else
				echo "modification impossible";
			echo JsUtils::doSomethingOn("#operation", "hide",200);
		}else{
			$id=str_replace("update", "", $id[0]);
			if(is_numeric($id)){
				$app=DAO::getOne("Application", "id=".$id);
				$useCases=DAO::getAll("UseCase", "idApplication=".$id);
				//logique client
				$js=JsUtils::postFormAndBindTo("#btValidAddApp", "click", "cApplication/update", "frmAddApp","#message",true);
				$js.=JsUtils::doSomeThingAndBindTo("#btCancelAddApp", "click", "#operation","hide",200);
				$js.=JsUtils::setHtmlAndBindTo("#btCancelAddApp", "click", "#message","Opération de mise à jour annulée");
				$js.=JsUtils::doSomethingOn("#operation", "show",400);
				//charegement vue
				$this->loadView("vAddApp", array("app"=>$app,"js"=>$js,"title"=>"Modifier l'application :","useCases"=>$useCases));
			}
		}
	}
	
	
	/**
	 * Confirmation de suppression
	 * @param integer $id
	 */
	public function confirmDelete($id){
		$id=str_replace("delete", "", $id[0]);
		//affichage confirmation suppression
		if(is_numeric($id)){
			echo "<div class='cadre'>Souhaitez vous supprimer l'application ? <a id='confirmDelete".$id."' href='#' class='accept'>Confirmer la suppression</a>";
			echo "<a id='cancelDelete' href='#' class='cancel'>Annuler</a>";
			echo JsUtils::getAndBindTo("#confirmDelete".$id, "click", "cApplication/delete/".$id,"{}","#message");
		}else{
			echo "<div class='cadre'>Souhaitez vous supprimer les applications sélectionnées ? <a id='confirmDelete".$id."' href='#' class='accept'>Confirmer la suppression</a>";
			echo "<a id='cancelDelete' href='#' class='cancel'>Annuler</a>";
	
			echo JsUtils::getAndBindTo("#confirmDelete".$id, "click", "cApplication/deleteMulti/".$id,"{}","#message");
		}
		//logique client
		echo JsUtils::doSomethingOn("#operation", "show",400);
		echo JsUtils::doSomeThingAndBindTo("#cancelDelete", "click", "#operation", "hide",200,JsUtils::_setHtml("#message","Suppression annulée"));
	}
	
	
	/**
	 * Suppression multiple
	 */
	public function deleteMulti(){
		//récupération id applications sélectionnées
		$selectedAppsId=SessionUtils::getArray("selectedApps");
		$nb=0;
		foreach ($selectedAppsId as $appId){
			//instanciation application
			$app=new Application();
			$app->setId($appId);
			//suppression
			if(DAO::delete($app)){
				SessionUtils::removeValueFromArray("selectedApps", $appId);
				$nb++;
			}
		}
		//logique client
		echo JsUtils::get("cApplication/refresh","{}","#apps");
		echo Gui::pluriel("application supprimée", "applications supprimées", $nb);
		echo JsUtils::doSomethingOn("#operation", "hide",200);
	}
	
	
	/**
	 * Suppression unique
	 * @param integer $id
	 */
	public function delete($id){
		$id=str_replace("delete", "", $id[0]);
		if(is_numeric($id)){
			//instanciation application
			$app=new Application();
			$app->setId($id);
			//suppression
			if(DAO::delete($app)){
				SessionUtils::removeValueFromArray("selectedApps", $id);
				Gui::showOne($app);
				echo " supprimé";
				echo JsUtils::get("cApplication/refresh","{}","#apps");
			}else {
				echo "Suppression impossible";
			}
		}
		//logique client
		echo JsUtils::doSomethingOn("#operation", "hide",200);
	}
	
	
	/**
	 * Sélection
	 * @param integer $id
	 */
	public function select($id){
		$id=str_replace("ck", "", $id[0]);
		if(is_numeric($id)){
			SessionUtils::addOrRemoveValueFromArray("selectedApps", $id);
			$nb=sizeof($_SESSION["selectedApps"]);
			if($nb>0)
				echo JsUtils::doSomethingOn("#multi", "show");
			else
				echo JsUtils::doSomethingOn("#multi", "hide");
			Gui::pluriel("application sélectionnée", "applications sélectionnées", $nb);
		}
	}
	
	
	/**
	 * Sélection complète 
	 */
	public function selectAll(){
		$nb=0;
		$ckAll=SessionUtils::checkBoolean("ckAllApps");
		if(!$ckAll){
			$_SESSION["selectedApps"]=array();
		}else{
			$_SESSION["selectedApps"]=explode(",", $_POST["ids"]);
			$nb=sizeof($_SESSION["selectedApps"]);
		}
		echo JsUtils::get("cApplication/refresh/","{}","#apps");
		echo Gui::pluriel("application sélectionnée", "applications sélectionnées", $nb);
	}
}
