<?php

class cConnexion extends BaseController{
	/**
	 * Contrôleur de gestion des connexions
	 */
	public function index($erreur=null){
		//ouverture du fichier de configuration
		$fh = fopen("dbSettings.php", "r");
		if($fh==false){
			die("Impossible de créer le fichier");
		}
		//récupération du nom de la base de données
		$dbName = file_get_contents("dbSettings.php");

		if(DAO::connect(trim($dbName))){
			//logique client
			$js=JsUtils::postFormAndBindTo("#btValidConnect", "click", $GLOBALS["siteUrl"]."/cConnexion/verifConnexion/", "frmConnexion","#frmConnexion");
			$js.=JsUtils::postFormAndBindTo("#btCancelConnect", "click", $GLOBALS["siteUrl"]."/cConnexion/index/", "frmConnexion","#frmConnexion");
		
			//chargement vue
			$this->loadView("vConnexion",array("erreur"=>$erreur,"js"=>$js));
		}else{
			//logique client
			$js=JsUtils::postFormAndBindTo("#btValid", "click", $GLOBALS["siteUrl"]."/cInstaller/saveSettings", "frmInstaller","#frmInstaller");
			
			//chargement vue
			$this->loadView("vInstaller",array("js"=>$js,"erreur"=>$erreur));
		}
	}
	
	
	/**
	 * Vérification de l'existence de l'utilisateur
	 */
	public function verifConnexion(){
		//ouverture du fichier de configuration
		$fh = fopen("dbSettings.php", "r");
		if($fh==false){
			die("Impossible de créer le fichier");
		}
		//récupération du nom de la base de données
		$dbName = file_get_contents("dbSettings.php");
		DAO::connect(trim($dbName));
		//instanciation user
		$user=new Utilisateur();
		RequestUtils::setValuesToObject($user,RequestUtils::getPost());
		
		//recherche user
		$result=DAO::getAll("utilisateur", "login='".$user->getLogin()."' and password='".sha1($user->getPassword())."'");

		//si user existe
		if(sizeof($result)==1){
			//enregistrement dans variable de session
			$_SESSION['userConnecte']=$result[0];
			
			//récupération groupe + droits
			$aGroupe=$_SESSION['userConnecte']->getGroupe();
			DAO::getOneToMany($aGroupe, "droits");
			
			$_SESSION['lesPages']="";
			$pages=array();
			foreach ($aGroupe->getDroits() as $droit) {
				//affectation module + groupe
				$droit->setModule(DAO::getOne("module", "id=".$droit->getIdModule()));
				$droit->setGroupe(DAO::getOne("groupe", "id=".$droit->getIdGroupe()));
				//récupération modules autorisés
				$module=$droit->getModule();
				//récupération pages par module
				DAO::getOneToMany($module, "pages");
				//récupération toutes pages par module
				foreach ($module->getPages() as $unePage){
					$pages[]=$unePage;
				}
			}
			
			//initialisation variables
			$_SESSION['lesPages']="";
			$pageDeconnexion="";
			
			//pour chaque page
			foreach ($pages as $aPage){
				//pour que la déconnexion soit à la fin du menu
				if($aPage->getControleur()=="cConnexion"){
					$pageDeconnexion=$aPage;
				}
				else{
					$_SESSION['lesPages'].=Gui::href($aPage);
				}
			}
			$_SESSION['lesPages'].=Gui::href($pageDeconnexion);
			
			//appel méthode accueil
			$this->accueil();
		}
		else{
			$this->index($erreur="Erreur de connexion");
		}
	}
	
	/**
	 * Accueil dans l'application lorsque connexion correcte
	 */
	public function accueil(){
		//chargement vues
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->loadView("vAccueil");
	}
}