<?php

class cDroit extends BaseController{
	/**
	 * Contrôleur de gestion des droits
	 */
	public function index(){
		//chargement vue
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		
		//init. var. session
		$_SESSION['choix']="groupes";
		$_SESSION['selectedGroups']=array();
		$_SESSION['selectedModules']=array();
		
		//chargement vue
		$this->loadView("vHeaderDroit");
		$this->refresh();
	}
	
	
	/**
	 * Rafraîchissement de la page
	 */
	public function refresh(){
		//récupération groupes + modules
		$_SESSION['groups']=DAO::getAll('groupe');
		$_SESSION['modules']=DAO::getAll('module');
		
		//création des tableaux, variables de session, contenant groupes sélectionnées + modules sélectionnés
		$selectedGroups=SessionUtils::getArray("selectedGroups");
		$selectedModules=SessionUtils::getArray("selectedModules");
 
		//logique client
		$js=JsUtils::getAndBindTo(".ckg", "click", $GLOBALS["siteUrl"]."/cDroit/selectRights","{}","#liste");
		$js.=JsUtils::setChecked("ckg", $selectedGroups);
		$js.=JsUtils::getAndBindTo(".ckm", "click", $GLOBALS["siteUrl"]."/cDroit/selectRights","{}","#liste");
		$js.=JsUtils::setChecked("ckm", $selectedModules);
		$js.=JsUtils::postAndBindTo("#affichageM", "click", $GLOBALS["siteUrl"]."/cDroit/choixAffichage",'{idChoix: $("#affichageM").val()}',"#tabs");
		$js.=JsUtils::postAndBindTo("#affichageG", "click", $GLOBALS["siteUrl"]."/cDroit/choixAffichage",'{idChoix: $("#affichageG").val()}',"#tabs");
		$js.=JsUtils::postAndBindTo("#btAdd", "click", $GLOBALS["siteUrl"]."/cDroit/add", "{}", "#liste");
		$js.=JsUtils::postAndBindTo("#btCancel", "click", $GLOBALS["siteUrl"]."/cDroit/refresh", "{}", "#rights");
		
		//chargement vues
		$this->loadView("vDroit",array("groupes"=>$_SESSION['groups'],"modules"=>$_SESSION['modules']));
		$this->loadView("vFooterDroit",array("js"=>$js));
	}
	
	
	/**
	 * Gestion des affichages des droits
	 * @param integer $id
	 */
	public function selectRights($id){
		//si on affiche par groupes
		if($_SESSION['choix']=="groupes"){
			//si on clique sur un groupe : affichage de tous les droits du groupe
			if(substr($id[0], 0, 3)=="ckg"){
				//récupération id groupe
				$id=str_replace("ckg", "", $id[0]);
				//ajout id groupe dans groupes sélectionnés
				SessionUtils::addOrRemoveValueFromArray("selectedGroups", $id);
				$_SESSION['lesDroitsDesGroupes']=array();
				foreach($_SESSION['selectedGroups'] as $idGroupe){
					foreach(DAO::getAll("droit", "idGroupe=".$idGroupe) as $aDroit){
						//récupération module + groupe
						$module=DAO::getOne("module", "id=".$aDroit->getIdModule());
						$groupe=DAO::getOne("groupe", "id=".$idGroupe);
						$aDroit->setGroupe($groupe);
						$aDroit->setModule($module);
						//ajout du droit dans variable de session
						$_SESSION['lesDroitsDesGroupes'][]=$aDroit;
					}
				}
				$_SESSION['lesDroitsDesGroupesTemporaires']=$_SESSION['lesDroitsDesGroupes'];
				//affichage des droits
				echo "<table>";
				echo "<tr><td width='10%'><b>&emsp;Groupe</b></td><td width='10%'><b>Module</b></td><td></td></tr>";
				foreach($_SESSION['lesDroitsDesGroupes'] as $aDroitParGroupe){
					echo Gui::selectRightByGroup($aDroitParGroupe);
				}
				echo JsUtils::postAndBindTo(".deleteOther", "click", $GLOBALS["siteUrl"]."/cDroit/delete", '{id: $(".deleteOther").val()}', "#liste");
				echo "</table>";
			}
			
			//si on clique sur un module : ajout des droits sur ces modules aux groupes
			if(substr($id[0], 0, 3)=="ckm"){
				if(sizeof($_SESSION['selectedGroups'])==0){
					echo "<b>Veuillez sélectionner un groupe avant de choisir un module</b>";
				}
				else{
				$id=str_replace("ckm", "", $id[0]);
				SessionUtils::addOrRemoveValueFromArray("selectedModules", $id);
				foreach($_SESSION['selectedModules'] as $lesModulesSelectionnes){
					foreach($_SESSION['selectedGroups'] as $lesGroupesSelectionnes){
						//instanciation nouveau droit
						$newDroit=new Droit();
						$newDroit->setGroupe(new Groupe($lesGroupesSelectionnes));
						$newDroit->setModule(new Module($lesModulesSelectionnes));
						$newDroit->setIdGroupe($lesGroupesSelectionnes);
						$newDroit->setIdModule($lesModulesSelectionnes);
						$newDroit->getGroupe()->setLibelle(DAO::getOne("groupe", "id=".$lesGroupesSelectionnes)->getLibelle());
						$newDroit->getModule()->setLibelle(DAO::getOne("module", "id=".$lesModulesSelectionnes)->getLibelle());
						$newDroit->getModule()->setDescriptif(DAO::getOne("module", "id=".$lesModulesSelectionnes)->getDescriptif());
						//recherche si le nouveau droit existe déjà
						$isAlreadyExist=$this->array_search_object($newDroit, $_SESSION['lesDroitsDesGroupesTemporaires']);
						//si n'existe pas : ajout dans la liste des droits
						if(!$isAlreadyExist){
							$_SESSION['lesDroitsDesGroupesTemporaires'][]=$newDroit;
						}
					}
				}
				//affichage des droits
				echo "<table>";
				echo "<tr><td width='10%'><b>&emsp;Groupe</b></td><td width='10%'><b>Module</b></td><td></td></tr>";
				foreach($_SESSION['lesDroitsDesGroupesTemporaires'] as $aDroitParGroupe){
					echo Gui::selectRightByGroup($aDroitParGroupe);
				}
				echo JsUtils::postAndBindTo(".deleteOther", "click", $GLOBALS["siteUrl"]."/cDroit/delete", '{id: $(".deleteOther").val()}', "#liste");
				echo "</table>";
				}
			}
		}
		//si on affiche par modules
		elseif($_SESSION['choix']=="modules"){
			//si on clique sur un module : affichage de tous les droits du module
			if(substr($id[0], 0, 3)=="ckm"){
				//récupération id module
				$id=str_replace("ckm", "", $id[0]);
				//ajout id module dans liste modules sélectionnés
				SessionUtils::addOrRemoveValueFromArray("selectedModules", $id);
				$_SESSION['lesDroitsDesModules']=array();
				foreach($_SESSION['selectedModules'] as $idModule){
					foreach(DAO::getAll("droit", "idModule=".$idModule) as $aDroit){
						//récupération groupe + module
						$groupe=DAO::getOne("groupe", "id=".$aDroit->getIdGroupe());
						$module=DAO::getOne("module", "id=".$idModule);
						$aDroit->setGroupe($groupe);
						$aDroit->setModule($module);
						//ajout droit dans la liste des droits
						$_SESSION['lesDroitsDesModules'][]=$aDroit;
					}
				}
				$_SESSION['lesDroitsDesModulesTemporaires']=$_SESSION['lesDroitsDesModules'];
				//affichage des droits
				echo "<table>";
				echo "<tr><td width='10%'><b>&emsp;Module</b></td><td width='10%'><b>Groupe</b></td><td></td></tr>";
				foreach($_SESSION['lesDroitsDesModules'] as $aDroitParModule){
					echo Gui::selectRightByModule($aDroitParModule);
				}
				echo JsUtils::postAndBindTo(".deleteOther", "click", $GLOBALS["siteUrl"]."/cDroit/delete", '{id: $(".deleteOther").val()}', "#liste");
				echo "</table>";
			}
				
			//si on clique sur un groupe : ajout des droits de ces groupes sur les modules
			if(substr($id[0], 0, 3)=="ckg"){
				if(sizeof($_SESSION['selectedModules'])==0){
					echo "<b>Veuillez sélectionner un module avant de choisir un groupe</b>";
				}
				else{
				//récupération id groupes sélectionnés
				$id=str_replace("ckg", "", $id[0]);
				//ajout id groupes sélectionnés dans la liste
				SessionUtils::addOrRemoveValueFromArray("selectedGroups", $id);
				$_SESSION['lesDroitsDesModulesTemporaires']=$_SESSION['lesDroitsDesModules'];
				foreach($_SESSION['selectedModules'] as $lesModulesSelectionnes){
					foreach($_SESSION['selectedGroups'] as $lesGroupesSelectionnes){
						//instanciation nouveau droit
						$newDroit=new Droit();
						$newDroit->setGroupe(new Groupe($lesGroupesSelectionnes));
						$newDroit->setModule(new Module($lesModulesSelectionnes));
						$newDroit->setIdGroupe($lesGroupesSelectionnes);
						$newDroit->setIdModule($lesModulesSelectionnes);
						$newDroit->getGroupe()->setLibelle(DAO::getOne("groupe", "id=".$lesGroupesSelectionnes)->getLibelle());
						$newDroit->getModule()->setLibelle(DAO::getOne("module", "id=".$lesModulesSelectionnes)->getLibelle());
						$newDroit->getModule()->setDescriptif(DAO::getOne("module", "id=".$lesModulesSelectionnes)->getDescriptif());
						//recherche si droit existe déjà
						$isAlreadyExist=$this->array_search_object($newDroit, $_SESSION['lesDroitsDesModulesTemporaires']);
						//si n'existe pas : ajout dans la liste des droits
						if(!$isAlreadyExist){
							$_SESSION['lesDroitsDesModulesTemporaires'][]=$newDroit;
						}
					}
				}
				//affichage des droits
				echo "<table>";
				echo "<tr><td width='10%'><b>&emsp;Module</b></td><td width='10%'><b>Groupe</b></td><td></td></tr>";
				foreach($_SESSION['lesDroitsDesModulesTemporaires'] as $aDroitParModule){
					echo Gui::selectRightByModule($aDroitParModule);
				}
				echo JsUtils::postAndBindTo(".deleteOther", "click", $GLOBALS["siteUrl"]."/cDroit/delete", '{id: $(".deleteOther").val()}', "#liste");
				echo "</table>";
			}
			}
		}
		
	}
	
	
	/**
	 * Ajout d'un droit
	 */
	public function add(){
		//si on affiche les droits par groupes
		if($_SESSION['choix']=="groupes"){
			//pour chaque groupes sélectionnés : récupération des droits
			foreach($_SESSION['selectedGroups'] as $idGroupe){
				$lesDroits=DAO::getAll("droit","idGroupe=".$idGroupe);
				foreach($lesDroits as $aDroit){
					//suppression de tous les droits de ces groupes
					DAO::delete($aDroit);
				}
			}
			foreach ($_SESSION['lesDroitsDesGroupesTemporaires'] as $aDroitTemporaire){
				//ajout des droits
				DAO::insert($aDroitTemporaire);
			}
			echo "Les nouveaux droits ont été enregistrés";
		}
		//si on affiche les droits par modules
		elseif($_SESSION['choix']=="modules"){
			//pour chaque modules sélectionnés : récupération des droits
			foreach($_SESSION['selectedModules'] as $idModule){
				$lesDroits=DAO::getAll("droit","idModule=".$idModule);
				foreach($lesDroits as $aDroit){
					//suppression de tous les droits de ces modules
					DAO::delete($aDroit);
				}
			}
			foreach ($_SESSION['lesDroitsDesModulesTemporaires'] as $aDroitTemporaire){
				//ajout des droits
				DAO::insert($aDroitTemporaire);
			}
			echo "Les nouveaux droits ont été enregistrés";
		}	
	}
	
	
	/**
	 * Suppression d'un droit
	 */
	public function delete(){
		//récupération de l'id de l'élément sélectionné
		$tab=array();
		$tab=explode("/",$_GET['c']);
		
		//récupération de l'id du groupe et de l'id du module
		$id=str_replace("delete", "", $tab[2]);
		$tab=explode("_", $id);
		$idModule=$tab[0];
		$idGroupe=$tab[1];
		
		//instanciation du droit à supprimer
		$droitToDelete=new Droit();
		$droitToDelete->setGroupe(new Groupe($idGroupe));
		$droitToDelete->setModule(new Module($idModule));
		$droitToDelete->setIdModule($idModule);
		$droitToDelete->setIdGroupe($idGroupe);
		$droitToDelete->getGroupe()->setLibelle(DAO::getOne("groupe", "id=".$idGroupe)->getLibelle());
		$droitToDelete->getModule()->setLibelle(DAO::getOne("module", "id=".$idModule)->getLibelle());
		$droitToDelete->getModule()->setDescriptif(DAO::getOne("module", "id=".$idModule)->getDescriptif());
	
		//si on affiche les droits par groupes
		if($_SESSION['choix']=="groupes"){	
			//recherche de la place de l'objet dans le tableau
			$key=array_search($droitToDelete, $_SESSION['lesDroitsDesGroupesTemporaires']);
			
			//suppression dans le tableau des droits temporaires
			unset($_SESSION['lesDroitsDesGroupesTemporaires'][$key]);

			//affichage des droits
			echo "<table>";
			echo "<tr><td width='10%'>&emsp;Groupe</td><td width='10%'>Module</td><td></td></tr>";
			foreach($_SESSION['lesDroitsDesGroupesTemporaires'] as $aDroitParGroupe){
				echo Gui::selectRightByGroup($aDroitParGroupe);
			}
		}
		//si on affiche les droits par modules
		elseif($_SESSION['choix']=="modules"){
			//recherche de la place de l'objet dans le tableau
			$key=array_search($droitToDelete, $_SESSION['lesDroitsDesModulesTemporaires']);
				
			//suppression dans le tableau des droits temporaires
			unset($_SESSION['lesDroitsDesModulesTemporaires'][$key]);
			
			//affichage des droits
			echo "<table>";
			echo "<tr><td width='10%'>&emsp;Module</td><td width='10%'>Groupe</td><td></td></tr>";
			foreach($_SESSION['lesDroitsDesModulesTemporaires'] as $aDroitParModule){
				echo Gui::selectRightByModule($aDroitParModule);
			}
		}
		echo JsUtils::postAndBindTo(".deleteOther", "click", $GLOBALS["siteUrl"]."/cDroit/delete", '{}', "#liste");
		echo "</table>";
	}
	
	
	/**
	 * Recherche si un objet est présent dans un tableau ou non
	 * @param object $object
	 * @param array $array
	 * @return boolean
	 */
	public static function array_search_object($object,$array){
		foreach ($array as $element) {
			if($element==$object){
				return true;
			}
		}
		return false;
	}
	
	
	/**
	 * Choix de l'affichage
	 */
	public function choixAffichage(){
		//init. var.
		$_SESSION['selectedGroups']=array();
		$_SESSION['selectedModules']=array();
		$_SESSION['choix']=$_POST['idChoix'];
		
		//appel de refresh
		$this->refresh();
	}
}