<?php

/**
 * Contrôleur de gestion des groupes
 * @author PENELOPE
 * @version 1.0.0.1
 */
class cGroupe extends \BaseController{

	/**
	 * Contrôleur de gestion des groupes
	 */
	public function index(){
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->refresh();
		$this->loadView("vFooter", array("message"=>"Gestion des groupes (Ajout, modification, suppression)"));
	}

	/**
	 * Utilisé pour l'affichage initial et le rafraîchissement après une modification
	 */
	public function refresh(){
		//Chargement des groupes $groups
		$groups=DAO::getAll("Groupe");
		//Application de la sélection des groupes
		$selectedGroups=SessionUtils::getArray("selectedGroups");
		
		$js=JsUtils::getAndBindTo("#btAdd", "click", "cGroupe/add","{}","#operation");
		$js.=JsUtils::getAndBindTo(".deleteOther", "click", "cGroupe/confirmDelete","{}","#operation");
		$js.=JsUtils::getAndBindTo(".update", "click", "cGroupe/update","{}","#operation");
		$js.=JsUtils::getAndBindTo(".ck", "click", "cGroupe/select","{}","#message");
		$js.=JsUtils::setChecked("ck", $selectedGroups);
		$js.=JsUtils::setChecked("ckAll", SessionUtils::getBoolean("ckAllGroups"));
		$js.=JsUtils::getAndBindTo("#deleteMulti", "click", "cGroupe/confirmDelete/multi","{}","#operation");
		if(sizeof($groups)>0)
			$js.=JsUtils::postAndBindTo("#ckAll", "click", "cGroupe/selectAll/",'{ids: $("input:checkbox[class=ck]").map(function(){return this.value;}).get().join(",")}',"#message");
		
		
		$nb=sizeof($selectedGroups);
		if($nb>0)
			$js.=JsUtils::doSomethingOn("#multi", "show");
		else
			$js.=JsUtils::doSomethingOn("#multi", "hide");
		
		$data=array("groups"=>$groups, "js"=>$js);
		$this->loadView("vGroups", $data);
		}
		
		
		
		
	public function add(){
		if($_SERVER['REQUEST_METHOD']=='POST'){
			$group=new Groupe();
			RequestUtils::setValuesToObject($group,$_POST);
			
			
			if(DAO::insert($group)){
				Gui::showOne($group);
				echo " ajouté";
				echo JsUtils::get("cGroupe/refresh","{}","#groups");
			}else
				echo "ajout impossible";
			echo JsUtils::doSomethingOn("#operation", "hide",200);
		}else{
			$js=JsUtils::postFormAndBindTo("#btValidAddGroup", "click", "cGroupe/add", "frmAddGroup","#message",true);
			$js.=JsUtils::doSomeThingAndBindTo("#btCancelAddGroup", "click", "#operation","hide",200);
			$js.=JsUtils::setHtmlAndBindTo("#btCancelAddGroup", "click", "#message","Opération d\'ajout annulée");
			$js.=JsUtils::doSomethingOn("#operation", "show",400);
		
			$group=new Groupe();
			$this->loadView("vAddGroup", array("group"=>$group,"js"=>$js,"title"=>"Ajouter un groupe :"));
		}
		}
		
		
		public function update($id){
			if($_SERVER['REQUEST_METHOD']=='POST'){
				$group=new Groupe();
				RequestUtils::setValuesToObject($group,RequestUtils::getPost());
				
				if(DAO::update($group)){
					Gui::showOne($group);
					echo " modifié";
					echo JsUtils::get("cGroupe/refresh","{}","#groups");
				}else
					echo "modification impossible";
				echo JsUtils::doSomethingOn("#operation", "hide",200);
			}else{
				$id=str_replace("update", "", $id[0]);
				if(is_numeric($id)){
					$group=DAO::getOne("Groupe", "id=".$id);
					$js=JsUtils::postFormAndBindTo("#btValidAddGroup", "click", "cGroupe/update", "frmAddGroup","#message",true);
					$js.=JsUtils::doSomeThingAndBindTo("#btCancelAddGroup", "click", "#operation","hide",200);
					$js.=JsUtils::setHtmlAndBindTo("#btCancelAddGroup", "click", "#message","Opération de mise à jour annulée");
					$js.=JsUtils::doSomethingOn("#operation", "show",400);
					$this->loadView("vAddGroup", array("group"=>$group,"js"=>$js,"title"=>"Modifier le groupe :"));
				}
			}
		}
		
		
		public function confirmDelete($id){
			$id=str_replace("delete", "", $id[0]);
			if(is_numeric($id)){
				echo "<div class='cadre'>Souhaitez vous supprimer le groupe ? <a id='confirmDelete".$id."' href='#' class='accept'>Confirmer la suppression</a>";
				echo "<a id='cancelDelete' href='#' class='cancel'>Annuler</a>";
				echo JsUtils::getAndBindTo("#confirmDelete".$id, "click", "cGroupe/delete/".$id,"{}","#message");
			}else{
				echo "<div class='cadre'>Souhaitez vous supprimer les groupes sélectionnés ? <a id='confirmDelete".$id."' href='#' class='accept'>Confirmer la suppression</a>";
				echo "<a id='cancelDelete' href='#' class='cancel'>Annuler</a>";
		
				echo JsUtils::getAndBindTo("#confirmDelete".$id, "click", "cGroupe/deleteMulti/".$id,"{}","#message");
			}
			echo JsUtils::doSomethingOn("#operation", "show",400);
			echo JsUtils::doSomeThingAndBindTo("#cancelDelete", "click", "#operation", "hide",200,JsUtils::_setHtml("#message","Suppression annulée"));
		}
		
		
		public function deleteMulti(){
			$selectedGroupId=SessionUtils::getArray("selectedGroups");
			$nb=0;
			foreach ($selectedGroupId as $groupId){
				$group=new Groupe();
				$group->setId($groupId);
				if(DAO::delete($group)){
					SessionUtils::removeValueFromArray("selectedGroups", $groupId);
					$nb++;
				}
			}
			echo JsUtils::get("cGroupe/refresh","{}","#groups");
			echo Gui::pluriel("groupe supprimé", "groupes supprimés", $nb);
			echo JsUtils::doSomethingOn("#operation", "hide",200);
		}
		
	
		public function delete($id){
			$id=str_replace("delete", "", $id[0]);
			if(is_numeric($id)){
				$group=new Groupe();
				$group->setId($id);
				if(DAO::delete($group)){
					SessionUtils::removeValueFromArray("selectedGroups", $id);
					Gui::showOne($group);
					echo " supprimé";
					echo JsUtils::get("cGroupe/refresh","{}","#groups");
				}else {
					echo "Suppression impossible";
				}
			}
			echo JsUtils::doSomethingOn("#operation", "hide",200);
		}
		
		
		public function select($id){
			$id=str_replace("ck", "", $id[0]);
			if(is_numeric($id)){
				SessionUtils::addOrRemoveValueFromArray("selectedGroups", $id);
				$nb=sizeof($_SESSION["selectedGroups"]);
				if($nb>0)
					echo JsUtils::doSomethingOn("#multi", "show");
				else
					echo JsUtils::doSomethingOn("#multi", "hide");
				Gui::pluriel("groupe sélectionné", "groupes sélectionnés", $nb);
			}
		}
		
		
		public function selectAll(){
			$nb=0;
			$ckAll=SessionUtils::checkBoolean("ckAllGroups");
			if(!$ckAll){
				$_SESSION["selectedGroups"]=array();
			}else{
				$_SESSION["selectedGroups"]=explode(",", $_POST["ids"]);
				$nb=sizeof($_SESSION["selectedGroups"]);
			}
			echo JsUtils::get("cGroupe/refresh/","{}","#groups");
			echo Gui::pluriel("groupe sélectionné", "groupes sélectionnés", $nb);
		}
}

