<?php 
/**
 * Création de la base de données
 * @author PENELOPE
 * @version 1.0.0.1
 */
class cInstaller extends BaseController{
	
	
	public function index(){
	}
	
	public function saveSettings(){
		//récupération du nom saisi
		$dbName=$_POST['dbname'];
		//si aucun nom saisi
		if($dbName==""){
			//affichage du formulaire de saisie
			$connexion=new cConnexion();
			$connexion->index("Veuillez saisir un nom pour la base de données");
		}
		else{
			//mise en minuscules
			$dbName=strtolower($dbName);
			
			//cherche s'il y a das caractères spéciaux, accents, espaces...
			$forbiddenCharacters=array('é','&','#','[',']','"','~','(',')','-','|','è','\\','ç','à','=','+','{','}','<','>','?','§','!',',',';','.','*',' ',"'",'@','^');
			$trouve=false;
			$i=0;
			while(($trouve==false)and($i<sizeof($forbiddenCharacters))){
				if(strpos($dbName, $forbiddenCharacters[$i])){
					$trouve=true;
				}
				$i++;
			}
			if($trouve){
				$connexion=new cConnexion();
				$connexion->index("Veuillez ne pas saisir de cractères spéciaux, ni d'accents, ni d'espaces");
			}else{
			
			//écriture du nom dans le fichier de configuration
			$fh = fopen("dbSettings.php", "w");
			if($fh == false){
				die("Impossible de créer le fichier");
			}
			fputs($fh, $dbName.PHP_EOL);
			fclose($fh);
		
			//création et remplissage de la base de données
			$req=array();
			
			//connexion à la base de données mysql
			DAO::connect("mysql");
			
			//requête de création de la base de données
			$req[]="CREATE DATABASE ".$dbName.";";
		
			//utilisation de la base créée
			$req[]="USE ".$dbName.";";
		
			//requêtes de création des tables
			$req[]="CREATE TABLE IF NOT EXISTS `groupe` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`libelle` varchar(50) NOT NULL,
  		PRIMARY KEY (`id`)
) 		ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `utilisateur` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`idGroupe` int(11) DEFAULT NULL,
  		`login` varchar(30) NOT NULL,
  		`password` varchar(40) NOT NULL,
  		`mail` varchar(255) NOT NULL,
  		PRIMARY KEY (`id`),
  		KEY `idGroupe` (`idGroupe`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=66 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `application` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`libelle` varchar(50) NOT NULL,
  		`descriptif` varchar(50) NOT NULL,
  		`version` varchar(20) NOT NULL,
  		`dateCreation` varchar(8) NOT NULL,
  		PRIMARY KEY (`id`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `affectation` (
  		`idApplication` int(11) NOT NULL,
 		`idUtilisateur` int(11) NOT NULL,
  		`dateAffectation` date DEFAULT NULL,
  		PRIMARY KEY (`idApplication`,`idUtilisateur`),
 		KEY `idUtilisateur` (`idUtilisateur`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
			$req[]="CREATE TABLE IF NOT EXISTS `module` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`libelle` varchar(100) DEFAULT NULL,
  		`descriptif` text,
  		PRIMARY KEY (`id`)
) 		ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `droit` (
  		`idGroupe` int(11) NOT NULL,
  		`idModule` int(11) NOT NULL,
  		PRIMARY KEY (`idGroupe`,`idModule`),
  		KEY `idModule` (`idModule`)
) 		ENGINE=InnoDB DEFAULT CHARSET=utf8;";
			$req[]="CREATE TABLE IF NOT EXISTS `page` (
  		`idPage` int(11) NOT NULL AUTO_INCREMENT,
  		`idModule` int(11) NOT NULL,
		`libelle` varchar(100) DEFAULT NULL,
  		`controleur` varchar(255) DEFAULT NULL,
  		PRIMARY KEY (`idPage`),
  		KEY `idModule` (`idModule`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `statut` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`libelle` varchar(50) DEFAULT NULL,
  		PRIMARY KEY (`id`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `usecase` (
  		`code` int(11) NOT NULL AUTO_INCREMENT,
  		`idApplication` int(11) NOT NULL,
  		`libelle` varchar(50) NOT NULL,
  		PRIMARY KEY (`code`),
  		KEY `idApplication` (`idApplication`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=17 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `report` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`idStatut` int(11) DEFAULT NULL,
  		`idUseCase` int(11) NOT NULL,
  		`idutilisateur` int(11) NOT NULL,
  		`libelle` varchar(100) DEFAULT NULL,
  		`descriptif` text,
  		`dateCreation` varchar(8) DEFAULT NULL,
  		`userAction` text,
  		`systemMessage` text,
  		`reponseOfficielle` text,
  		PRIMARY KEY (`id`),
  		KEY `FK_REPORTERSUR` (`idUseCase`),
  		KEY `idStatut` (`idStatut`),
  		KEY `idutilisateur` (`idutilisateur`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;";
			$req[]="CREATE TABLE IF NOT EXISTS `message` (
  		`id` int(11) NOT NULL AUTO_INCREMENT,
  		`idReport` int(11) NOT NULL,
  		`idUtilisateur` int(11) NOT NULL,
 	 	`objet` varchar(255) DEFAULT NULL,
  		`contenu` text,
  		`dateEnvoi` varchar(8) DEFAULT NULL,
  		PRIMARY KEY (`id`),
  		KEY `idReport` (`idReport`),
  		KEY `idUtilisateur` (`idUtilisateur`)
		) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;";
		
		
			//requêtes de création des contraintes
			$req[]="ALTER TABLE `affectation`
  		ADD CONSTRAINT `affectation_ibfk_2` FOREIGN KEY (`idUtilisateur`) REFERENCES `utilisateur` (`id`) ON DELETE CASCADE,
  		ADD CONSTRAINT `affectation_ibfk_3` FOREIGN KEY (`idApplication`) REFERENCES `application` (`id`) ON DELETE CASCADE;";
			$req[]="ALTER TABLE `droit`
  		ADD CONSTRAINT `droit_ibfk_1` FOREIGN KEY (`idGroupe`) REFERENCES `groupe` (`id`) ON DELETE CASCADE,
  		ADD CONSTRAINT `droit_ibfk_2` FOREIGN KEY (`idModule`) REFERENCES `module` (`id`);";
			$req[]="ALTER TABLE `message`
  		ADD CONSTRAINT `message_ibfk_1` FOREIGN KEY (`idReport`) REFERENCES `report` (`id`) ON DELETE CASCADE,
  		ADD CONSTRAINT `message_ibfk_2` FOREIGN KEY (`idUtilisateur`) REFERENCES `utilisateur` (`id`) ON DELETE CASCADE;";
			$req[]="ALTER TABLE `page`
  		ADD CONSTRAINT `page_ibfk_1` FOREIGN KEY (`idModule`) REFERENCES `module` (`id`);";
			$req[]="ALTER TABLE `report`
  		ADD CONSTRAINT `report_ibfk_4` FOREIGN KEY (`idStatut`) REFERENCES `statut` (`id`) ON DELETE CASCADE,
  		ADD CONSTRAINT `report_ibfk_5` FOREIGN KEY (`idUseCase`) REFERENCES `usecase` (`code`) ON DELETE CASCADE,
  		ADD CONSTRAINT `report_ibfk_6` FOREIGN KEY (`idutilisateur`) REFERENCES `utilisateur` (`id`) ON DELETE CASCADE;";
			$req[]="ALTER TABLE `usecase`
  		ADD CONSTRAINT `usecase_ibfk_1` FOREIGN KEY (`idApplication`) REFERENCES `application` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;";
			$req[]="ALTER TABLE `utilisateur`
  		ADD CONSTRAINT `utilisateur_ibfk_2` FOREIGN KEY (`idGroupe`) REFERENCES `groupe` (`id`) ON DELETE SET NULL;";
		
		
			//requêtes d'insertion
			$req[]="INSERT INTO `application` (`id`, `libelle`, `descriptif`, `version`, `dateCreation`) VALUES
		(1, 'BugReport', 'remontée d''incidents', '1.0.0.1', '10-12-13'),
		(2, 'GSB-Gestion de frais', 'gestion des frais de visite', '1.0.0.1', '10-12-13'),
		(3, 'Suivi de livraisons', 'suivi des livraisons', '1.0.0.1', '10-12-13'),
		(4, 'Gestion des carrières des cadres', 'gestion carrières professionnelles des cadres', '1.0.0.1', '10-12-13'),
		(5, 'GestionParcInfo', 'gestion du parc informatique', '1.0.0.1', '10-12-13'),
		(6, 'Gestion de projets', 'gestion des projets', '1.0.0.1', '15-12-13');";
			$req[]="INSERT INTO `usecase` (`code`, `idApplication`, `libelle`) VALUES
		(1, 1, 'supprimer un groupe'),
		(2, 1, 'modifier un groupe'),
		(3, 1, 'ajouter un groupe'),
		(4, 1, 'supprimer un utilisateur'),
		(5, 1, 'modifier un utilisateur'),
		(6, 1, 'ajouter un utilisateur'),
		(7, 3, 'connexion à l application'),
		(8, 3, 'supprimer une commande'),
		(9, 3, 'modifier une commande'),
		(10, 3, 'ajouter une commande'),
		(11, 4, 'gestion des affectations'),
		(12, 5, 'connexion à l application'),
		(13, 6, 'connexion à l application'),
		(14, 1, 'connexion à l application'),
		(15, 6, 'ajouter un projet'),
		(16, 2, 'connexion à l application');";
			$req[]="INSERT INTO `statut` (`id`, `libelle`) VALUES
		(1, 'Créé'),
		(2, 'Affecté aux Dévs'),
		(3, 'Répondu'),
		(4, 'En attente réponse'),
		(5, 'Résolu'),
		(6, 'Non résolu');";
			$req[]="INSERT INTO `module` (`id`, `libelle`, `descriptif`) VALUES
		(1, 'Administration', 'Pages liées à  l''administration, gestions des pages, modules, groupes, utilisateurs'),
		(2, 'Public', 'Pages accessibles sans être connecté'),
		(3, 'Utilisateur', 'Pages destinées aux reports de bug...'),
		(4, 'Gestion des Reports et des Applications', 'Suivi des reports, affectation des développeurs'),
		(5, 'Deconnexion', 'Pages liées à la déconnexion de l''application');";
			$req[]="INSERT INTO `page` (`idPage`, `idModule`, `libelle`, `controleur`) VALUES
		(1, 1, 'Gestion des utilisateurs', 'cUtilisateur'),
		(2, 1, 'Gestion des groupes', 'cGroupe'),
		(3, 4, 'Gestion des applications', 'cApplication'),
		(4, 3, 'Rechercher un report', 'cReport/indexListeReport'),
		(5, 3, 'Saisir un report', 'cReport/indexSaisieReport'),
		(6, 5, 'Déconnexion', 'cConnexion'),
		(7, 4, 'Affectation de développeurs', 'cAffectation'),
		(8, 1, 'Gestion des droits', 'cDroit'),
		(9, 3, 'Mes reports', 'cReport/indexMesReports');";
			$req[]="INSERT INTO `groupe` (`id`, `libelle`) VALUES
		(1, 'Utilisateurs'),
		(2, 'Administrateurs'),
		(3, 'Chefs de projet'),
		(4, 'Développeurs'),
		(5, 'Tech. Réseaux'),
		(6, 'groupe de projet');";
			$req[]="INSERT INTO `droit` (`idGroupe`, `idModule`) VALUES
		(2, 1),
		(1, 2),
		(2, 2),
		(3, 2),
		(4, 2),
		(5, 2),
		(1, 3),
		(2, 3),
		(3, 3),
		(4, 3),
		(5, 3),
		(3, 4),
		(1, 5),
		(2, 5),
		(3, 5),
		(4, 5),
		(5, 5);";
			$req[]="INSERT INTO `utilisateur` (`id`, `idGroupe`, `login`, `password`, `mail`) VALUES
		(3, 3, 'jcheron', '7110eda4d09e062aa5e4a390b0a572ac0d2c0220', 'myaddressmail@gmail.com'),
		(12, 4, 'Charly BEAUGRAND', 'f7c3bc1d808e04732adf679965ccc34ca7ae3441', ''),
		(15, 4, 'Anthony GAUTREAU', '20eabe5d64b0e216796e834f52d61fd0b70332fc', ''),
		(26, 2, 'Administrateur', '8104ba1dc0409b259f487ed07db477c38f205a30', ''),
		(39, 4, 'Pénélope GIROD', '48058e0c99bf7d689ce71c360699a14ce2f99774', ''),
		(41, 2, 'root', 'eb117fa18203d7e20419e78f1e997364a77783ae', ''),
		(42, 3, 'DarkVador', '7b8a3112ef78e0208358cc3c1141fb4fa0aa138a', ''),
		(43, 4, 'Jordi FERTE', '7c4a8d09ca3762af61e59520943dc26494f8941b', ''),
		(47, 5, 'Joachim HODEMOND', 'f7c3bc1d808e04732adf679965ccc34ca7ae3441', ''),
		(48, 4, 'Arnaud VINCENT', '39dfa55283318d31afe5a3ff4a0e3253e2045e43', ''),
		(49, 4, 'Romain BERTRAND', '571a47254f4383b47dc24dbb5da02ac2e4b037b5', ''),
		(50, 4, 'Maxime DONGE', 'dbaa30de22b1129ec140a188fc3c06a6af8e9f1f', ''),
		(51, 5, 'Alexandre AXEL', '2d663df28f689a6b0f44e265f73e50d5e3af6b7f', ''),
		(52, 4, 'Florian BRIENS', 'b1af8adc5baaa1284c9e91b4df5ed301200a3753', ''),
		(53, 5, 'Florian ROBIN', 'ec4cba6ca3bcaa3c0b184781c8fb3e0b52e3fe6b', ''),
		(54, 5, 'Camille HENRY', '2c50d9402e832863195f5372dabc9a3b307de353', ''),
		(55, 5, 'Audrey GERSAN', '57f3b39122010f58a4f941c3e01b81c018ad7fe2', ''),
		(58, 5, 'Donovan MORIN', 'bfed8c0ee8f23147035a46fdf6f6246d187f92b4', ''),
		(60, 4, 'Pierrick HUE', '39dfa55283318d31afe5a3ff4a0e3253e2045e43', ''),
		(61, 3, 'chief', 'c4b038d0316060f704c271350dae0f568717db26', ''),
		(62, 2, 'admin', 'd033e22ae348aeb5660fc2140aec35850c4da997', ''),
		(63, 1, 'user', '12dea96fec20593566ab75692c9949596833adc9', ''),
		(64, 4, 'dev', '34c6fceca75e456f25e7e99531e2425c6c1de443', ''),
		(65, 5, 'res', 'dee1ebcd105d3d47adf43aba6fd674e80d1dc35f', '');";
			$req[]="INSERT INTO `affectation` (`idApplication`, `idUtilisateur`, `dateAffectation`) VALUES
		(1, 42, '2014-12-13');";
			$req[]="INSERT INTO `report` (`id`, `idStatut`, `idUseCase`, `idutilisateur`, `libelle`, `descriptif`, `dateCreation`, `userAction`, `systemMessage`, `reponseOfficielle`) VALUES
		(1, 5, 16, 61, 'connexion impossible', 'la connexion à l''application n''est pas possible', '16-12-13', 'saisie du login et du mot de passe, puis clic sur le bouton valider', 'Erreur de connexion', '');";
			$req[]="INSERT INTO `message` (`id`, `idReport`, `idUtilisateur`, `objet`, `contenu`, `dateEnvoi`) VALUES
		(1, 1, 63, 'même problème', 'j''ai le même problème de connexion : impossible de se connecter à l''application', '16-12-13');";
		
			//exécution de toutes les requêtes
			foreach($req as $aRequest){
				DAO::$db->execute($aRequest);
			}
			
			//connexion à l'application
			$connexion=new cConnexion();
			$connexion->index("");
			}
		}
	}
}
?>