<?php

class cReport extends BaseController{
	/**
	 * implémentée parce que fonction abstraite dans BaseController
	 */
	public function index(){
		
	}
	
	/**
	 * contrôleur de gestion de la saisie des reports
	 */
	public function indexSaisieReport(){
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->saisieReport();
		$this->loadView("vFooter",array("message"=>"Gestion des reports"));
	}
	
	/**
	 * contrôleur de gestion de la recherche de report
	 */
	public function indexListeReport(){
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->listeReport();
	}
	
	/**
	 * contrôleur de gestion d'affichage des reports de l'utilisateur connecté
	 */
	public function indexMesReports(){
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$this->mesReports();
	}
	
	
	/**
	 * affichage du formulaire dans le cas de la saisie d'un report
	 */
	public function saisieReport(){
		$apps=DAO::getAll("Application");
		//affichage des applications qui ont des cas d'utilisation
		$appsAAfficher=array();
		foreach($apps as $app){
			DAO::getOneToMany($app, "useCases");
			$useCase=array();
			foreach($app->getUseCases() as $uc){
				$useCase[]=$uc;
			}
			if(sizeof($useCase)>=1){
				$appsAAfficher[]=$app;
			}
		}
		$js=JsUtils::postAndBindTo(".application", "click", $GLOBALS["siteUrl"]."cReport/choixUseCaseSaisieReport","{idApplication: $(this).attr('id')}","#useCase");
		$this->loadView("vSaisieReport",array("apps"=>$appsAAfficher,"js"=>$js));
	}
	
	/**
	 * liste les applications
	 */
	public function listeReport(){
		$apps=DAO::getAll("Application");
		//affichage des applications qui ont des cas d'utilisation
		$appsAAfficher=array();
		foreach($apps as $app){
			DAO::getOneToMany($app, "useCases");
			$useCase=array();
			foreach($app->getUseCases() as $uc){
				$useCase[]=$uc;
			}
			if(sizeof($useCase)>=1){
				$appsAAfficher[]=$app;
			}
		}
		$js=JsUtils::postAndBindTo(".application", "click", $GLOBALS["siteUrl"]."cReport/choixUseCaseListeReport","{idApplication: $(this).attr('id')}","#useCase");
		$this->loadView("vRechercheReport",array("apps"=>$appsAAfficher,"js"=>$js));
	}
	
	/**
	 * choix d'un use case
	 */
	public function choixUseCase(){
		$idApplication=$_POST['idApplication'];
		$useCases=DAO::getAll('UseCase', 'idApplication='.$idApplication);
		
		if(sizeof($useCases)>0)
			echo "<b>Choisir un cas d'utilisation :</b><br />".Gui::affichageRadioButton('useCase', $useCases);
		else
			echo "<b>Aucun cas d'utilisation existant</b>";
		echo"<br /><br /><br />";
	}
	
	/**
	 * choix d'un use case
	 */
	public function choixUseCaseSaisieReport(){
		$this->choixUseCase();
		echo JsUtils::postAndBindTo(".useCase", "click", $GLOBALS["siteUrl"]."cReport/afficherComposants", "{}", "#detail");
	}
	
	/**
	 * choix d'un use case
	 */
	public function choixUseCaseListeReport(){
		$this->choixUseCase();
		echo JsUtils::postAndBindTo(".useCase", "click", $GLOBALS["siteUrl"]."cReport/afficherValidation", "{}", "#detail");
	}
	
	/**
	 * affiche les composants de formulaire pour la saisie d'un report
	 */
	public function afficherComposants(){
		echo Gui::affichageComposantTexte("Libellé", "libelle");
		echo Gui::affichageComposantTexteArea("Descriptif", "descriptif");
		echo Gui::affichageComposantTexteArea("Action utilisateur", "userAction");
		echo Gui::affichageComposantTexteArea("Message système", "systemMessage");
		echo '<input type="hidden" name="dateCreation" id="dateCreation" value="'.date('d-m-y').'"/>';
		echo '<div class="buttons"><div id="btValidAddReport" class="btn" title="Envoyer le report">Valider</div><div id="btCancelAddReport" class="btn" title="Annuler le report">Annuler</div></div>';
		echo JsUtils::postAndBindTo("#descriptif", "keydown", $GLOBALS["siteUrl"]."/cReport/afficheReportsSimilaires","$('#saisieReport').serialize()","#reportsSimilaires");
		echo JsUtils::postAndBindTo("#userAction", "keydown", $GLOBALS["siteUrl"]."/cReport/afficheReportsSimilaires","$('#saisieReport').serialize()","#reportsSimilaires");
		echo JsUtils::postAndBindTo("#systemMessage", "keydown", $GLOBALS["siteUrl"]."/cReport/afficheReportsSimilaires","$('#saisieReport').serialize()","#reportsSimilaires");
		echo JsUtils::postAndBindTo("#btValidAddReport", "click", $GLOBALS["siteUrl"]."/cReport/add","$('#saisieReport').serialize()","#message");
		echo JsUtils::setAttr("#libelle", "required",true);
	}
	
	/**
	 * affichage bouton validation recherche report
	 */
	public function afficherValidation(){
		echo '<div align="center" class="buttons"><div id="btValidRechercheReport" class="btn">Rechercher dans les reports...</div></div>';
		echo JsUtils::postAndBindTo("#btValidRechercheReport", "click", $GLOBALS["siteUrl"]."/cReport/recherche","$('#rechercheReport').serialize()","#reportsCorrespondants");
	}
	
	/**
	 * affichage reports similaires
	 */
	public function afficheReportsSimilaires(){
		$reportCree=new Report();
		RequestUtils::setValuesToObject($reportCree,$_POST);
		
		$lesReports=DAO::getAll('Report');
		$lesReportsSimilaires=array();
		
		$searchEngine=new SearchEngine();
		foreach ($lesReports as $aReport) {
			if($searchEngine->compare($reportCree, $aReport))
				$lesReportsSimilaires[]=$aReport;
		}
		
		if(sizeof($lesReportsSimilaires)>0){
			echo "<br /><div align='center'><b>Reports similaires</b></div><br />";
			echo "<table id='reportsTable' border='1'>";
			echo "<tr align='center'><td>Libellé</td><td>Descriptif</td><td>Action utilisateur</td><td>Message du système</td></tr>";
			foreach($lesReportsSimilaires as $report){
				echo "<tr><td>".$report->getLibelle()."</td><td>".$report->getDescriptif()."</td><td>".$report->getUserAction()."</td><td>".$report->getSystemMessage()."</td></tr>";
			}
			echo "</table>";
		}
	}
	
	/**
	 * ajout d'un report dans la BDD
	 */
	public function add(){
		if($_SERVER['REQUEST_METHOD']=='POST'){
			$report=new Report();
			RequestUtils::setValuesToObject($report,$_POST);
			$report->setUtilisateur(new Utilisateur($_SESSION['userConnecte']->getId()));
			$report->setStatut(new Statut("1"));
			$report->setUseCase(new UseCase($_POST['useCase']));

			if(DAO::insert($report)){
				echo "Report ";
				Gui::showOne($report);
				echo " ajouté";
			}else
				echo "ajout impossible";
			echo JsUtils::doSomethingOn("#detail", "hide",200);
			echo JsUtils::get($GLOBALS["siteUrl"]."/cReport/saisieReport","{}","#reports");
		}
	}
	
	/**
	 * affichage reports du cas d'utilisation
	 */
	public function recherche(){
		$idUseCase=$_POST['useCase'];
		$reports=array();
		$reports=DAO::getAll("report","idUseCase=".$idUseCase);
		echo "<fieldset class='cadre'><legend>Reports correspondants</legend>";
		if(sizeof($reports)>0){
			echo "<table id='reportsTable' border='0'>";
			echo "<tr><td align='center'><b>Libellé</b></td><td align='center' width='150'><b>Date de création</b></td><td align='center' width='150'><b>Nombre de messages</b></td><td align='center' width='100'><b>Résolu</b></td></tr>";
			foreach ($reports as $aReport) {
				echo Gui::selectReport($aReport);
			}
			echo "</table>";
		}else{
			echo "<b>Aucun report trouvé</b>";
		}
		echo "</fieldset>";
	}
	
	/**
	 * affichage report
	 */
	public function afficherReport(){
		$this->loadView("vHeader",array("lesPages"=>$_SESSION['lesPages']));
		$tab=explode("/", $_GET['c']);
		$idReport=$tab[2];
		
		$report=DAO::getOne("report", "id='".$idReport."'");
		$js=JsUtils::postAndBindTo("#btValidChoiceMessage", "click", $GLOBALS["siteUrl"]."/cReport/createMessage/".$report->getId(), "{}", "#message");
		$this->loadView("vListeMessage",array("report"=>$report, "js"=>$js));
	}
	
	/**
	 * chargement de l'interface d'ajout d'un message
	 */
	public function createMessage($id){
		$js=JsUtils::postAndBindTo("#btValidAddMessage", "click", $GLOBALS["siteUrl"]."/cReport/addMessage", "$('#frmAddMessage').serialize()", "#message");
		$js.=JsUtils::setHtmlAndBindTo("#btCancelAddMessage", "click", "#message", "Opération d\'envoi annulée");
		$caseReponseOfficielle="";
		if($_SESSION['userConnecte']->getGroupe()->getId()=="3"){
			$caseReponseOfficielle="<input type='checkbox' name='reponseOfficielle' id='reponseOfficielle' title='Souhaitez-vous que votre message soit la réponse officielle du report ?'/>Réponse officielle";
		}
		$this->loadView("vAddMessage",array("idReport"=>$id[0],"case"=>$caseReponseOfficielle, "js"=>$js));
	}
	
	/**
	 * ajout du message
	 */
	public function addMessage(){
		if($_SERVER['REQUEST_METHOD']=='POST'){
			//il s'agit de la réponse officielle au report
			if(isset($_POST['reponseOfficielle'])){
				$report=DAO::getOne("report", "id=".$_POST['idReport']);
				$report->setReponseOfficielle($_POST['contenu']);
				$report->setStatut(new Statut("5"));
				if(DAO::update($report)){
					echo "Votre réponse officielle a été enregistrée. Elle ne sera affichée que lorsque le modérateur du site aura contrôlé son contenu.";
				}
			}
			//il s'agit d'un message "simple"
			else{
				$message=new Message();
				RequestUtils::setValuesToObject($message,$_POST);
				$date=date('d-m-y');
				$report=new Report($_POST['idReport']);
				$report->setStatut(new Statut("3"));
				DAO::update($report);
				$message->setDateEnvoi($date);
				$message->setReport(new Report($_POST['idReport']));
				$message->setUtilisateur(new Utilisateur($_SESSION['userConnecte']->getId()));
				if(DAO::insert($message)){
					echo "Votre message '".$message->getObjet()."' a été enregistré. Il ne sera affiché que lorsque le modérateur du site aura contrôlé son contenu.";
				}
			}
		}
	}
	
	
	/**
	 * affichage des reports de l'utilisateur connecté
	 */
	public function mesReports(){
		$reports=DAO::getAll("report", "idutilisateur=".$_SESSION['userConnecte']->getId());
		$this->loadView("vMesReports", array("reports"=>$reports));
	}
}