<?php
/**
 * Classe technique destinée à la conception des interfaces
 * @author jc
 *
 */
class Gui{
	/**
	 * Affiche un objet ou un tableau d'objets en appliquant au préalable la méthode $method à chacun d'entre eux 
	 * @param mixed $values Valeur(s) à afficher
	 * @param string $method Méthode de la classe GUI ou de la classe de $value
	 */
	public static function show($values,$method='toString'){
		if(is_array($values)){
			foreach ($values as $v){
				Gui::showOne($v,$method);
			}
		}else 
			Gui::showOne($values,$method);
	}
	
	/**
	 * Affiche un objet $value en lui ayant au préalable appliqué la méthode $method
	 * @param Object $value
	 * @param string $method Méthode de la classe GUI ou de la classe de $value
	 */
	public static function showOne($value,$method='toString'){
		echo Gui::getOne($value,$method);
	}
	
	public static function getOne($value,$method='toString'){
		if(method_exists("GUI", $method)){
			$value=GUI::$method($value);
		}else{
			if(method_exists($value, $method)){
				$value=$value->$method();
			}else{
				$value=$value.'';
			}
		}
		return $value;
	}
	
	
	public static function addDelete($value){
		return "<tr><td class='element'><input title='Sélectionner' type='checkbox' class='ck' id='ck".$value->getId()."' value='".$value->getId()."'><span title='Modifier...' class='update' id='update".$value->getId()."'>&nbsp;".$value->toString()."<span></td><td><span title='Supprimer...' class='deleteOther' id='delete".$value->getId()."'>&nbsp;</span></td></tr>";
	}
	
	public static function addDeleteUser($value){
		return "<tr><td class='element'><input title='Sélectionner' type='checkbox' class='ck' id='ck".$value->getId()."' value='".$value->getId()."'><span title='Modifier...' class='update' id='update".$value->getId()."'>&nbsp;".$value->toString()."<span></td><td><span title='Supprimer...' class='delete' id='delete".$value->getId()."'>&nbsp;</span></td></tr>";
	}
	
	public static function addDeleteGroup($value){
		return "<tr><td class='element'><input title='Sélectionner' type='checkbox' class='ck' id='ck".$value->getId()."' value='".$value->getId()."'><span title='Modifier...' class='update' id='update".$value->getId()."'>&nbsp;".$value->toStringCountUser()."<span></td><td><span title='Supprimer...' class='deleteOther' id='delete".$value->getId()."'>&nbsp;</span></td></tr>";
	}
	
	public static function select($value){
		return "<option class='element' id='element".$value->getId()."' value='".$value->getId()."'>".$value->toString()."</option>";
	}
	
	public static function checkbox($value){
		return "<input title='Sélectionner' type='checkbox' class='ck' id='ck".$value->getId()."' value='".$value->getId()."'>".$value->getLibelle()."<br />";
	}
	
	public static function checkboxAssignedUser($value){
		return "<input title='Sélectionner' type='checkbox' class='ckd' id='ckd".$value->getId()."' value='".$value->getId()."'><img src='".$GLOBALS['siteUrl']."/images/cancel.png' />".$value->getLogin()."<br />";
	}
	
	public static function checkboxUnassignedUser($value){
		return "<input title='Sélectionner' type='checkbox' class='cka' id='cka".$value->getId()."' value='".$value->getId()."'>".$value->getLogin()."<br />";
	}

	public static function checkboxGroupes($value){
		return "<input title='Sélectionner' type='checkbox' class='ckg' id='ckg".$value->getId()."' value='".$value->getId()."'>".$value->getLibelle()."<br />";
	}
	
	public static function checkboxModules($value){
		return "<input title='Sélectionner' type='checkbox' class='ckm' id='ckm".$value->getId()."' value='".$value->getId()."'>".$value->getLibelle()."<br />";
	}
	
	public static function href($value){
		return "&emsp;<a href='".$GLOBALS["siteUrl"]."/".$value->getControleur()."'>".$value->getLibelle()."</a>&emsp;|";
	}
	
	public static function selectReport($value){
		$resolu=$value->getReponseOfficielle();
		if($resolu){
			$resolu="<img src='".$GLOBALS['siteUrl']."/images/accept.png' />";
		}
		else{
			$resolu="<img src='".$GLOBALS['siteUrl']."/images/error.png' />";
		}
		DAO::getOneToMany($value, "messages");
		return "<tr><td><a id='reportSelected' href='".$GLOBALS["siteUrl"]."/cReport/afficherReport/".$value->getId()."'>".$value->getLibelle()."</td><td align='center'>".$value->getDateCreation()."</td><td align='center'>".sizeof($value->getMessages())."</td><td align='center'>".$resolu."</td></tr>";
	}
	
	public static function selectMesReports($value){
		$resolu=$value->getReponseOfficielle();
		if($resolu){
			$resolu="<img src='".$GLOBALS['siteUrl']."/images/accept.png' />";
		}
		else{
			$resolu="<img src='".$GLOBALS['siteUrl']."/images/error.png' />";
		}
		DAO::getOneToMany($value, "messages");
		return "<tr><td><a id='reportSelected' href='".$GLOBALS["siteUrl"]."/cReport/afficherReport/".$value->getId()."' title='Afficher le report'>".$value->getUseCase()->getApplication()->getLibelle()."</a></td><td>".$value->getusecase()->getLibelle()."</td><td>".$value->getLibelle()."</td><td align='center'>".$value->getDateCreation()."</td><td align='center'>".sizeof($value->getMessages())."</td><td align='center'>".$resolu."</td></tr>";
	}
	
	public static function selectRightByGroup($value){
		return "<tr><td width='10%'>&emsp;".$value->getGroupe()->getLibelle()."</td><td width='18%'>".$value->getModule()->getLibelle()."</td><td><span title='Supprimer...' class='deleteOther' id='delete".$value->getModule()->getId()."_".$value->getGroupe()->getId()."'>&nbsp;</span></td></tr>";
	}
	
	public static function selectRightByModule($value){
		return "<tr><td width='20%'>&emsp;".$value->getModule()->getLibelle()."</td><td width='10%'>".$value->getGroupe()->getLibelle()."</td><td><span title='Supprimer...' class='deleteOther' id='delete".$value->getModule()->getId()."_".$value->getGroupe()->getId()."'>&nbsp;</span></td></tr>";
	}
	
	/**
	 * Retourne l'expression $singulier au pluriel en fonction du nombre $nb
	 * @param string $singulier
	 * @param string $pluriel
	 * @param int $nb
	 */
	public static function pluriel($singulier,$pluriel,$nb){
		if($nb==0){
			echo "Aucun ".$singulier;
		}else{
			printf(ngettext("%d ".$singulier, "%d ".$pluriel, $nb),$nb);
		}
	}
	
	/**
	 * Retourne le code HTML d'affichage d'une liste
	 * @param string $libelle
	 * @param string $idListe
	 * @param array $data
	 * @return string $code
	 */
	public static function affichageListe($libelle, $idListe, $data){
		//initialisation de la variable avec le libelle
		$code=$libelle." :";
	
		//code pour la liste déroulante
		$code.="<select name='".$idListe."' id='".$idListe."'>";
		$code.="<option value='0'>--Faire un choix--</option>";
		foreach ($data as $uc){
			$code.="<option value='".$uc->getId()."'>".$uc->getLibelle()."</option>";
		}
		$code.="</select>";
	
		//retour du code
		return $code;
	}
	
	/**
	 * Retourne le code HTML d'affichage d'une liste
	 * @param string $name
	 * @param array $data
	 * @return string $code
	 */
	public static function affichageRadioButton($name, $data){
		//code pour les boutons radios
		$code="";
		foreach ($data as $uc){
			if ($uc instanceof useCase) 
				$code.="<input type='radio' class='".$name."' id='".$uc->getCode()."' name='".$name."' value='".$uc->getCode()."'>".$uc->getLibelle()."<br />";
			else
				$code.="<input type='radio' class='".$name."' id='".$uc->getId()."' name='".$name."' value='".$uc->getId()."'>".$uc->getLibelle()."<br />";
		}
		
		//retour du code
		return $code;
	}
	
	
	/**
	 * Retourne le code HTML d'affichage d'un composant texte de formulaire
	 * @param string $libelle
	 * @param string $idComposant
	 * @return string $code
	 */
	public static function affichageComposantTexte($libelle, $idComposant){
		//code pour le composant texte de formulaire
		$code='<label class="label" for="'.$idComposant.'">'.$libelle.'* :</label><input title="'.$libelle.'" placeholder="Votre '.$libelle.'" type="text" name="'.$idComposant.'" id="'.$idComposant.'" value="" size="50" maxlength="255" required/><br />';
	
		//retour du code
		return $code;
	}
	
	
	
	/**
	 * Retourne le code HTML d'affichage d'un composant texte de formulaire
	 * @param string $libelle
	 * @param string $idComposant
	 * @return string $code
	 */
	public static function affichageComposantTexteArea($libelle, $idComposant){
		//code pour le composant texte de formulaire
		$code='<label class="label" for="'.$libelle.'">'.$libelle.'* :</label><textarea rows="7" cols="35" name="'.$idComposant.'" id="'.$idComposant.'" title="'.$libelle.'"></textarea>&emsp;';
		
		//retour du code
		return $code;
	}
	
	
	/**
	 * Retourne le code HTML d'affichage d'une case à cocher de formulaire
	 * @param string $libelle
	 * @param string $idComposant
	 * @return string $code
	 */
	public static function affichage($libelle, $idComposant){
		//code pour le composant texte de formulaire
		//$code='<label class="label" for="'.$libelle.'">'.$libelle.'* :</label><input title="'.$libelle.'" placeholder="Votre '.$libelle.'" type="text" name="'.$idComposant.'" id="'.$idComposant.'" value="" maxlength="" required/>&emsp;';
		$code='<label class="label" for="'.$libelle.'">'.$libelle.'* :</label><textarea rows="7" cols="35" name="'.$idComposant.'" id="'.$idComposant.'"></textarea>&emsp;';
	
		//retour du code
		return $code;
	}
	
	public static function encode($array){
		foreach ($array as $element){
			utf8_encode($element->getLogin());
		}
		return $array;
	}
}