<?php

require_once 'C:\xampp\htdocs\bugReport\classes\SearchEngine.php';
require_once 'C:\xampp\htdocs\bugReport\classes\Report.php';

/**
 * Test class for SearchEngine.
 * Generated by PHPUnit on 2013-10-03 at 11:19:36.
 */
class SearchEngineTest extends PHPUnit_Framework_TestCase{
	
	private $engine;
	
	public function setUp(){
		$this->engine=new SearchEngine();
	}
	
	public function testCleanWord(){
		$word1 = "salute";
		$word2 = "sallute";
		$word3 = "saluté";
		$word1 = $this-> engine->cleanWord($word1);
		$word2 = $this-> engine->cleanWord($word2);
		$word3 = $this-> engine->cleanWord($word3);
		$this->assertTrue($word1==$word2);
		$this->assertEquals($word2, $word3);
	}
	
	public function testCompareWord(){
		$word1 = "salute";
		$word2 = "saluté";
		$this->engine->setOption("wordComp", 100);
		$this->assertTrue($this->engine->wordCompare($word1, $word2));
		/*$this->assertTrue($this-> engine->wordCompare($word1,$word2));
		$this->assertTrue($this-> engine->wordCompare($word2,$word3));
		$this->assertTrue($this-> engine->wordCompare($word1,$word4));*/
	}
	
	public function testCleanExpression(){
		$expression1="essai d'expression trait-d'union et, virgule,point";
		$this->assertEquals("esai expresion trait union virgule point", $this->engine->cleanExpression($expression1));
	}

	public function testContainsWord(){
		$aWord="test";
		$anExpression="cette chaîne contient le mot Tests à l'intérieur";
		$this->assertTrue($this->engine->containsWord($aWord, $anExpression));
	}
	
	public function testExpressionCompare(){
		$expression1="Impossible de valider le formulaire de saisie d'un nouveau bug";
		$expression2="Formulaire de report de bug impossible à valider";
		$this->engine->setOption("expressionComp", 1/2);
		$this->assertTrue($this->engine->expressionCompare($expression1, $expression2));
	}
	public function testCompare(){
		$report1=new Report("bugReport", "Ajouter un report");
		$report1->setValues("Erreur système", "Click sur un bouton", "Impossible de valider le formulaire de saisie d'un nouveau bug");
		$this->engine->setOption("expressionComp", 1/2);
		$report2=new Report("bugReport", "Ajouter un report");
		$report2->setValues("Erreurs", "Click", "Formulaire de report de bug impossible à valider");
		$this->assertTrue($this->engine->compare($report1, $report2));
	}
}
?>
